PROC GLOBAL 
set explicit

file myhh myhl mywm mych;
numeric notoccur i hloccur edoccur ovoccur cloccur daoccur mmoccur j;

PROC MICS3_FF

PROC HH

{ EXPORT HH }
set behavior() export (SPSS SubitemOnly);

export to myhh
  HH1,HH2,MODHH, MODTO, MODWS, MODHC, MODCD, MODHE, MODHI;

{ EXPORT HH MEMBERS }
notoccur = 999;       { HH member's occurrence number if not listed in module  }
i = 1;
while i <= HH11 do
  hloccur = HL1(i);      { HH member's occurrence number in the HL module  }
  edoccur = notoccur;    { HH member's occurrence number in the ED module  }
  ovoccur = notoccur;    { HH member's occurrence number in the OV module  }
  cloccur = notoccur;    { HH member's occurrence number in the CL module  }
  daoccur = notoccur;    { HH member's occurrence number in the DA module  }
  mmoccur = notoccur;    { HH member's occurrence number in the MM module  }
  { Determine HH member's occurrence number in ED module [notoccur if not present] }
  j = 1;
  while j <= noccurs(MODED) do
    if ED1(j) = hloccur then
      edoccur = j;
      j = noccurs(MODED);
    endif;
    j = j + 1;
  enddo;
  { Determine HH member's occurrence number in OV module [notoccur if not present] }
  {j = 1;
  while j <= noccurs(MODOR) do
    if OV8A(j) = hloccur then
      ovoccur = j;
      j = noccurs(MODOR);
    endif;
    j = j + 1;
  enddo;}
  { Determine HH member's occurrence number in CL module [notoccur if not present] }
  j = 1;
  while j <= noccurs(MODCL) do
    if CL1(j) = hloccur then
      cloccur = j;
      j = noccurs(MODCL);
    endif;
    j = j + 1;
  enddo;
  { Determine HH member's occurrence number in DA module [notoccur if not present] }
  j = 1;
  while j <= noccurs(MODDA) do
    if DA1(j) = hloccur then
      daoccur = j;
      j = noccurs(MODDA);
    endif;
    j = j + 1;
  enddo;
  { Determine HH member's occurrence number in MM module [notoccur if not present] }
  j = 1;
  {while j <= noccurs(MODMM) do
    if MM1(j) = hloccur then
      mmoccur = j;
      j = noccurs(MODMM);
    endif;
    j = j + 1;
  enddo;}
  { Export the HH member }
  export to myhl
    HH1,HH2,MODHL(hloccur),MODED(edoccur),MODCL(cloccur),MODDA(daoccur),MODHH,MODWS,MODHC;
  { Increment the counter }
  i = i + 1;
enddo;

PROC WMCH

{ EXPORT WOMEN }
if HL6(LN) > 0 then
  export to mywm
    HH1,HH2,LN,MODWM, MODCM, MODMN, MODMA, MODST, MODCP, MODDV, MODSB, MODHA, MODHH, MODWS, MODHC;
endif;

{ EXPORT CHILDREN }
if HL8(LN) > 0 then
  export to mych
    HH1,HH2,LN,MODUF, MODBR, MODCE, MODBF, MODCA, MODIM, MODAN, HL4(UF4), ED3A(UF6), MODHH, MODWS, MODHC;
endif;
